#include <EEPROM.h>
int SET=3; // deklarace tlačítka
int OUT = 5; //deklarace výstupu
int Led = 10; // Led 1 na pinu 10
int PORUCHA=9; // Led signalizující poruchy 
boolean Kontrolka = false; // proměná stav LED diody
unsigned long Cas = 0; // zde si uložíme čas poslední zmeny

int hystereze = 8;// hystereze proti rozkmitání

int sensor =A0; //deklarace analogového pinu s fotoodporem
int pot = A1; //deklarace pinu s trimrem
int svetlo,trimr;// deklarace proměnných
int StavTrimru,IntenzitaSvetla;//-||-
byte pamet;// deklarace EEPROM proměnné

int rezim = 0;// deklarace režimu

void blikani(int pin){// funkce blikání*************************************************
  digitalWrite(pin, Kontrolka);
   if ((millis() - Cas) > 250){
      Cas = millis();
      Kontrolka = !Kontrolka;}
    }

void setup() {//****************************************************************
pinMode(SET,INPUT);
pinMode(sensor,INPUT);
pinMode(pot,INPUT);
pinMode(OUT,OUTPUT);
pinMode(Led, OUTPUT);
pinMode(PORUCHA,OUTPUT);
digitalWrite(PORUCHA,LOW);
}

void loop() {
pamet= EEPROM.read(1);// načtení EEPROM
svetlo = analogRead(sensor);//čtení hodnoty z Fotoodporu
IntenzitaSvetla = svetlo/4;//konverze hodnoty z INTEGER na BYTE
trimr= analogRead(pot);//čtení hodnoty z potenciometru
StavTrimru=map(trimr,0,1023,1,75);//konverze hodnoty na dráhu potenciometru

  if ((svetlo<=1)|| (svetlo==1023)){// Ochrana při přerušení čidla či zkratu čidla
  blikani(PORUCHA);
digitalWrite(OUT,LOW);}

else {
  digitalWrite(PORUCHA,LOW);

if (rezim>2){rezim=0;}// ochrana proti překročení proměnné
if (digitalRead(SET)==LOW) {rezim++;delay(300);}// nastavení tlačítka

if (rezim==0) {digitalWrite(Led, LOW);// režim 0, nastavenou hodnotu porovnává z EEPROM
  if (IntenzitaSvetla<=(pamet-hystereze)){digitalWrite(OUT,0);}
  else if (IntenzitaSvetla>=(pamet)){digitalWrite(OUT,1);}
  }

  if (rezim==1) {blikani(Led);// režim 1, nastavenou hodnotu porovnává z potenciometru
    if (IntenzitaSvetla<=(StavTrimru-hystereze)){digitalWrite(OUT,0);}
  else if (IntenzitaSvetla>=(StavTrimru)){digitalWrite(OUT,1);}}

if (rezim==2) { // uložení nastavené hodnoty z potenciometru do EEPROM
  digitalWrite(Led,HIGH);digitalWrite(PORUCHA,HIGH);
  delay(500);EEPROM.update(1,StavTrimru);
  rezim++;}
}}

